-- Demonstration of constants, type, and functions in 'unknown.e'

include unknown.e

procedure write (integer fn, sequence p)
   print(fn, p[1])
   for i = 2 to length(p) do
      puts(fn, " / ") print(fn, p[i])
   end for
   puts(fn, "\n")
end procedure


integer ofn
sequence test
uNum u, a, b
u = UNKNOWN

ofn = open("unknown.txt", "w")
test = {7,4, 7,0, 7,u, 0,4, 0,0, 0,u, u,4, u,0, u,u}

puts(ofn, "* Logical operations *\n")
for i = 1 to 17 by 2 do
   a = test[i]
   b = test[i+1]
   write(ofn, {u_not(a), u_and(a, b), u_or(a, b), u_xor(a, b)})
end for
puts(ofn, '\n')

puts(ofn, "* Relational operations *\n")
for i = 1 to 17 by 2 do
   a = test[i]
   b = test[i+1]
   write(ofn, {u_equ(a, b), u_lt(a, b), u_lte(a, b), u_gt (a, b), u_gte(a, b)})
end for
puts(ofn, '\n')

puts(ofn, "* Arithmetic operations *\n")
for i = 1 to 17 by 2 do
   a = test[i]
   b = test[i+1]
   write(ofn, {u_neg(a), u_add(a, b), u_sub(a, b), u_mul(a, b), u_div(a, b)})
end for
close(ofn)
